/*
 * Copyright 2011 Hanson Robokind LLC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * PlayableStatusPanel.java
 *
 * Created on Jul 20, 2011, 11:42:54 PM
 */
package org.rwshop.swing.common;

import org.robokind.api.common.playable.PlayState;
import org.robokind.api.common.playable.PlayableListener;

/**
 *
 * @author Matthew Stevenson <www.robokind.org>
 */
public class PlayableStatusPanel extends javax.swing.JPanel implements PlayableListener{
    /** Creates new form PlayableStatusPanel */
    public PlayableStatusPanel() {
        initComponents();
    }
    
    public void changeLabel(String lbl){
        lblLabel.setText(lbl);
    }
    
    public void setStatusText(String txt){
        lblStatus.setText(txt);
    }
    
    @Override
    public void playStateChanged(PlayState prev, PlayState state, long time) {
        lblStatus.setText(state.toString());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblLabel = new javax.swing.JLabel();
        lblStatus = new javax.swing.JLabel();

        lblLabel.setText("Status:");

        lblStatus.setText("uninitialized");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(lblLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblStatus))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(lblLabel)
                .addComponent(lblStatus))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lblLabel;
    private javax.swing.JLabel lblStatus;
    // End of variables declaration//GEN-END:variables

}
